//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSynEditor *SynEditor;
//---------------------------------------------------------------------------
__fastcall TSynEditor::TSynEditor(TComponent* Owner)
        : TForm(Owner)
{
  prepgesture = false;
}
//---------------------------------------------------------------------------

void __fastcall TSynEditor::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if( Button == mbRight )
  {
    prepgesture = true;
    startgesture.x = X;
    startgesture.y = Y;
    movegesture.x = X;
    movegesture.y = Y;
    gesture = "";
    dirgesture = 0;
    dirrepgesture = 0;
    SynEditor->Canvas->MoveTo( X, Y );
    SynEditor->Canvas->Pen->Color = clBlack;
  }
}
//---------------------------------------------------------------------------
void __fastcall TSynEditor::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if( prepgesture )
  {
    SynEditor->Canvas->LineTo( X, Y );
    int dir = GetGestureDirection( movegesture, X, Y );
    if( dir > 0 )
    {
      if( dir != dirgesture )
      {
        if( dirrepgesture == 0 )
        {
          gesture.Delete( gesture.Length(), 1 );
        }
        gesture += AnsiString( dir );
        dirgesture = dir;
        dirrepgesture = 0;

        Edit1->Text = gesture;
      }
      else dirrepgesture++;
      movegesture.x = X;
      movegesture.y = Y;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TSynEditor::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if( Button == mbRight )
  {
    prepgesture = false;
    SynEditor->Invalidate();
    if( gesture != "" )
    {
      // well here we should execute out gesture
      if( gesture == "26" ) Close();
      if( gesture == "1" ) MessageBeep(0);
    }
  }
}
//---------------------------------------------------------------------------

int TSynEditor::GetGestureDirection ( TPoint start, int X, int Y )
{
  // Rckgabewert entspricht Ziffer auf Nummernpad
  const dist = 20;
  int dx = X - start.x;
  int dy = Y - start.y;
  if( (fabs(dx)<dist) && (fabs(dy)<dist) ) return 0;

  if( fabs(dx) < fabs( dy / 2 ) )
  {
    // vertical movement
    if( dy > 0 ) return 2;
    if( dy < 0 ) return 8;
  }

  if( fabs(dy) < fabs( dx / 2 ) )
  {
    // horizontal movement
    if( dx > 0 ) return 6;
    if( dx < 0 ) return 4;
  }

  // diagonal movement
  if( (dx > 0) && (dy > 0 ) ) return 3;
  if( (dx > 0) && (dy < 0 ) ) return 9;
  if( (dx < 0) && (dy > 0 ) ) return 1;
  if( (dx < 0) && (dy < 0 ) ) return 7;

  return 0;
}


